////////////////////////////////////////////////////////////////////////////////
//
//      IBM Confidential
//
//      OCO Source Materials
//
//      The source code for this program is not published or otherwise
//      divested of its trade secrets, irrespective of what has
//      been deposited with the U.S. Copyright Office.
//
//      Copyright:      Licensed Materials - Property of IBM
//
//      (C) Copyright IBM Corp. 1999, 2001
//      All rights reserved.
//
//      U.S. Government Users Restricted Rights -
//      Use, duplication or disclosure restricted by
//      GSA ADP Schedule Contract with IBM Corp.
//
// Product: IBM WebSphere Host Publisher
//
// Component: HOD Bean
//
////////////////////////////////////////////////////////////////////////////////
package IntegrationObject;

import com.ibm.HostPublisher.IntegrationObject.*;
import com.ibm.HostPublisher.Server.Ras;

import java.lang.*;
import java.beans.*;


public class Chaining_Example1 extends HPubHODCommon  
{

  // Generated Objects
  HAOVariable author_results = new HAOVariable("","author_results","author_results",false,"",0,0,79,15,HAO_VARIABLE_SIMPLE);
  HAOVariable author_input = new HAOVariable("author_input","null","author_input",true,"",0,0,63,0,HAO_VARIABLE_SIMPLE);

  HAOVariable author_resultsnumbers = new HAOVariable("","author_results","author_resultsnumbers",false,"",0,0,4,15,HAO_VARIABLE_ARRAY);
  HAOVariable author_resultsbook_titles = new HAOVariable("","author_results","author_resultsbook_titles",false,"",4,0,75,15,HAO_VARIABLE_ARRAY);


  // Contructor
  public Chaining_Example1()
  { // Generated vector population
    vHAOVariables.addElement(author_results);
    vHAOVariables.addElement(author_input);


    vHAOVariables.addElement(author_resultsnumbers);
    vHAOVariables.addElement(author_resultsbook_titles);

    hPubStartPoolName  = new String("chain_pool");
    hPubStartChainName = null;
    hPubStartType         = BEAN_START_FROM_POOL;



    hPubEndChainName   = new String("chain_stop");
    hPubEndType           = BEAN_END_TO_CONNECTION;


    stringHODMacroFilename = "Chaining_Example1.macro";
    stringBeanName = new String("Chaining_Example1");

   }


  // *************************************************************************
  /* Generated Setters */

  public void setAuthor_input( String stringToBe)
  {
    hPubErrorOccurred = 0;
    allowTracing();  // call made in case started from IDE and was not able to
                     // start tracing on the constructor
    if (HPubTracingOn) { Ras.traceEntry( this.getClass().getName(),"setAuthor_input(String)", stringToBe); }

    author_input.stringValue = stringToBe;
  }

  /* Generated Getters */
  public String getAuthor_results()
  {
     hPubErrorOccurred = 0;
     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getAuthor_results simple: ", author_results.stringValue); }
     return (author_results.stringValue);
  }
  public String getAuthor_input()
  {
     hPubErrorOccurred = 0;
     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getAuthor_input simple: ", author_input.stringValue); }
     return (author_input.stringValue);
  }

  public synchronized String getAuthor_resultsnumbers(int i)
  {
     hPubErrorOccurred = 0;
     if (  (author_resultsnumbers.oMultiValues.size() != 0)
         &&(i >= 0)
         &&(i < author_resultsnumbers.oMultiValues.size())
        )
     { 
       if (HPubTracingOn)
       { Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getAuthor_resultsnumbers array: ",
           integerX.toString(), (String) author_resultsnumbers.oMultiValues.elementAt(i));
       }

       return ( (String) author_resultsnumbers.oMultiValues.elementAt(i));
     }
     else
     { if (HPubTracingOn)
       {
         Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getAuthor_resultsnumbers array element ", "Throwing out of bounds on iteration: ",
           integerX.toString());
       }

       throw new ArrayIndexOutOfBoundsException("Row is Out of Bounds");
     }
  }

  public String[] getAuthor_resultsnumbers()
  {
     hPubErrorOccurred = 0;

     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getAuthor_resultsnumbers ", "array all"); }

     author_resultsnumbers.oStringArray = new String[author_resultsnumbers.oMultiValues.size()];
     author_resultsnumbers.oMultiValues.copyInto(author_resultsnumbers.oStringArray);
     return (String[])author_resultsnumbers.oStringArray.clone();
  }
  public synchronized String getAuthor_resultsbook_titles(int i)
  {
     hPubErrorOccurred = 0;
     if (  (author_resultsbook_titles.oMultiValues.size() != 0)
         &&(i >= 0)
         &&(i < author_resultsbook_titles.oMultiValues.size())
        )
     { 
       if (HPubTracingOn)
       { Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getAuthor_resultsbook_titles array: ",
           integerX.toString(), (String) author_resultsbook_titles.oMultiValues.elementAt(i));
       }

       return ( (String) author_resultsbook_titles.oMultiValues.elementAt(i));
     }
     else
     { if (HPubTracingOn)
       {
         Integer integerX = new Integer(i);
         Ras.trace( this.getClass().getName(),"getAuthor_resultsbook_titles array element ", "Throwing out of bounds on iteration: ",
           integerX.toString());
       }

       throw new ArrayIndexOutOfBoundsException("Row is Out of Bounds");
     }
  }

  public String[] getAuthor_resultsbook_titles()
  {
     hPubErrorOccurred = 0;

     if (HPubTracingOn) { Ras.trace( this.getClass().getName(),"getAuthor_resultsbook_titles ", "array all"); }

     author_resultsbook_titles.oStringArray = new String[author_resultsbook_titles.oMultiValues.size()];
     author_resultsbook_titles.oMultiValues.copyInto(author_resultsbook_titles.oStringArray);
     return (String[])author_resultsbook_titles.oStringArray.clone();
  }


  public String getHPubBeanName()
  { return new String("Chaining_Example1");
  }

  public void DoTheWork()
  {
    DoTheWork(this);
  }

}


