////////////////////////////////////////////////////////////////////////////////
//
//      IBM Confidential
//
//      OCO Source Materials
//
//      The source code for this program is not published or otherwise
//      divested of its trade secrets, irrespective of what has
//      been deposited with the U.S. Copyright Office.
//
//      Copyright:      Licensed Materials - Property of IBM
//
//      (C) Copyright IBM Corp. 1999, 2001
//      All rights reserved.
//
//      U.S. Government Users Restricted Rights -
//      Use, duplication or disclosure restricted by
//      GSA ADP Schedule Contract with IBM Corp.
//
// Product: IBM WebSphere Host Publisher
//
// Component: HOD Bean
//
////////////////////////////////////////////////////////////////////////////////
package IntegrationObject;

import java.beans.*;
import java.lang.reflect.*;
import java.lang.*;
import java.util.*;
import com.ibm.HostPublisher.IntegrationObject.*;

public class Chaining_Example2BeanInfo extends SimpleBeanInfo
{ 
   ResourceBundle res = ResourceBundle.getBundle("com.ibm.HostPublisher.IntegrationObject.HPub_Resources",
                                                 Locale.getDefault());

   public BeanInfo[] getAdditionalBeanInfo()
   {
     try
     {
       BeanInfo hPubBi1 = Introspector.getBeanInfo(Chaining_Example2.class.getSuperclass());
 
       BeanInfo[] arrayOfBIs = { hPubBi1 };
       return arrayOfBIs;
     }
     catch (IntrospectionException e)
     {
       e.printStackTrace();
     }

     return null;
   }

  public PropertyDescriptor[] getPropertyDescriptors()
  { try
    { // Generated Code
      String stringPackageName =  new String("IntegrationObject");


      String hPubHODVariablePropDesc = res.getString("hPubHODVariablePropDesc");

     
      PropertyDescriptor pdBook_information = new PropertyDescriptor("book_information", Class.forName(stringPackageName + "." + "Chaining_Example2"),
                                        "getBook_information",null);

      pdBook_information.setShortDescription(hPubHODVariablePropDesc);
      PropertyDescriptor pdNumber_input = new PropertyDescriptor("number_input", Class.forName(stringPackageName + "." + "Chaining_Example2"),
                                        "getNumber_input","setNumber_input");

      pdNumber_input.setShortDescription(hPubHODVariablePropDesc);
     



      PropertyDescriptor pdHPubXMLProperties = new PropertyDescriptor("hPubXMLProperties",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubXMLProperties",null); 
      String hPubXMLPropDesc = res.getString("hPubXMLPropDesc");
      pdHPubXMLProperties.setShortDescription(hPubXMLPropDesc);

      PropertyDescriptor pdHPubStartPoolName = new PropertyDescriptor("hPubStartPoolName",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubStartPoolName","setHPubStartPoolName"); 
      String hPubStartPoolNamePropDesc = res.getString("hPubStartPoolNameDescPropDesc");
      pdHPubStartPoolName.setShortDescription(hPubStartPoolNamePropDesc);

      PropertyDescriptor pdHPubStartChainName = new PropertyDescriptor("hPubStartChainName",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubStartChainName", null); 
      String hPubStartChainNamePropDesc = res.getString("hPubStartChainNamePropDesc");
      pdHPubStartChainName.setShortDescription(hPubStartChainNamePropDesc);

      PropertyDescriptor pdHPubEndChainName = new PropertyDescriptor("hPubEndChainName",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubEndChainName", null); 
      String hPubEndChainNamePropDesc = res.getString("hPubEndChainNamePropDesc");
      pdHPubEndChainName.setShortDescription(hPubEndChainNamePropDesc);

      PropertyDescriptor pdHPubStartType = new PropertyDescriptor("hPubStartType",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubStartType", null); 
      String hPubStartTypePropDesc = res.getString("hPubStartTypePropDesc");
      pdHPubStartType.setShortDescription(hPubStartTypePropDesc);

      PropertyDescriptor pdHPubEndType = new PropertyDescriptor("hPubEndType",
                                                     com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                     "getHPubEndType", null); 
      String hPubEndTypePropDesc = res.getString("hPubEndTypePropDesc");
      pdHPubEndType.setShortDescription(hPubEndTypePropDesc);

      PropertyDescriptor pdHPubErrorException = new PropertyDescriptor("hPubErrorException",
                                                    com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                    "getHPubErrorException", null); 
      String hPubExceptionPropDesc = res.getString("hPubExceptionPropDesc");
      pdHPubErrorException.setShortDescription(hPubExceptionPropDesc);

      PropertyDescriptor pdHPubLinkKey = new PropertyDescriptor("hPubLinkKey",
                                                    com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, 
                                                    "getHPubLinkKey", "setHPubLinkKey"); 
      String hPubLinkKeyPropDesc = res.getString("hPubLinkKeyPropDesc");
      pdHPubLinkKey.setShortDescription(hPubLinkKeyPropDesc);



      PropertyDescriptor[] arrayOfPDs = { 
                                          pdBook_information,
                                          pdNumber_input,
                                          pdHPubXMLProperties,
                                          pdHPubStartPoolName,
                                          pdHPubStartChainName,
                                          pdHPubEndChainName,
                                          pdHPubStartType,
                                          pdHPubEndType,
                                          pdHPubErrorException,
                                          pdHPubLinkKey
                                        };
      return arrayOfPDs;
    }
    catch (Exception e) 
    { System.out.println(e);
      return null;
    }
  }

  // ***** *****
  public MethodDescriptor[] getMethodDescriptors() 
  {
     try
     { 
        MethodDescriptor md1 = new MethodDescriptor(getMethod(com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, "processRequest"));
        String procReqDesc = res.getString("procReqDesc");
        md1.setShortDescription(procReqDesc);


        MethodDescriptor md2 = new MethodDescriptor(getMethod(com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, "doHPTransaction"));
        String doHPTransDesc = res.getString("doHPTransDesc");
        md2.setShortDescription(doHPTransDesc);
        
        // method for receiving event
        MethodDescriptor md3 = new MethodDescriptor(getMethod(com.ibm.HostPublisher.IntegrationObject.HPubCommon.class, "hPubStartPerformed")); 
        String hPubStartPerfDesc = res.getString("hPubStartPerfDesc");
        md3.setShortDescription(hPubStartPerfDesc);

        MethodDescriptor[] arrayOfMDs = { md1,
                                          md2,
                                          md3
                                        }; 
        return arrayOfMDs;
     
      } 
      catch (IntrospectionException e) 
      {
        e.printStackTrace();
      }
      return null;
  }

  Method getMethod(Class cls, String methodName) throws IntrospectionException 
  { Method methods[] = cls.getMethods();

    for (int i=0; i < methods.length; i++)
    { if (methods[i].getName().equals(methodName))
      { return methods[i];
      }
    }
    throw new IntrospectionException("No method \"" + methodName);
  }

  // ***** *****
  public EventSetDescriptor[] getEventSetDescriptors()
  { try
    {  EventSetDescriptor eventHPubReqComplete = 
         new EventSetDescriptor(com.ibm.HostPublisher.IntegrationObject.HPubCommon.class,
                                "requestComplete",
                                com.ibm.HostPublisher.IntegrationObject.HPubReqCompleteListener.class,
                                "hPubReqComplete");
       
       String reqCompleteName = res.getString("reqCompleteName");
       eventHPubReqComplete.setDisplayName(reqCompleteName);
       String reqCompleteDesc = res.getString("reqCompleteDesc");
       eventHPubReqComplete.setShortDescription(reqCompleteDesc);


       EventSetDescriptor[] arrayOfESDs = {
                                           eventHPubReqComplete
                                          };

       return arrayOfESDs;
    }
    catch (IntrospectionException e) 
    { System.out.println(e);
      return null;
    }
  }

}



